#include once "vec2f.bi"
#include once "fbsound.bi"


type sound_bank

	as vec2f p
	
	as single vol, pan
	
	as integer sound, loops

	as byte following = false
	
	as byte inQueue

	as vec2f ptr followHost

	declare sub follow()

end type


type wav_file
	
	as string sName
	
	as integer wav
	
end type


type sound_source

	as string sName

	as vec2f p

	as sound_bank soundBank(any)

	declare function set_follow_host( byval toFollow as vec2f ptr, byref id as integer = 0 ) as byte

end type


type music_source
	
	as string sName
	
	as vec2f p
	
	as integer soundBank
	
end type


type sound_system

	declare constructor()

	declare destructor()

	as uinteger PAN_FALLOFF = 400, DIST_FALLOFF = 96000
	
	as single SCALE_FALLOFF = 1

	as vec2f p

	as wav_file soundFile(any)

	as sound_source source(any)

	as wav_file musicFile(any)

	as music_source music 

	declare sub update()

	declare sub set_listener_position( byref position as vec2f )

	declare function get_listener_position() as vec2f

	declare sub set_source_position( byref id as integer, byref position as vec2f )

	declare sub set_source_pause( byref id as integer, byref state as boolean, byref bankID as integer = 0 )

	declare function load_wav( byref fName as string ) as uinteger

	declare function add_source( byref wavId as integer, byref count as integer, byref nam as string = "sound" ) as uinteger

	declare sub play_source( byref id as integer, byref loops as integer )
	
	declare function load_song( byref fName as string ) as uinteger
	
	declare sub play_song( byref id as uinteger, byref loops as integer = 0 )
	
end type
