#include "display.bi"
#include "vec2f.bi"
#include "fbtriangles.bi"
#include "sound.bi"
#include "entity.bi"


extern levWidth as integer
extern levHeight as integer
extern zBuff as single ptr


dim as integer levWidth
dim as integer levHeight
dim as single ptr zBuff


screenres 640,480,32

levWidth = 640
levHeight = 480
zBuff = new single[levWidth*levHeight]



declare function wait_key( byref Key as uinteger ) as byte

dim as model_struct model


dim as camera_struct cam
dim as byte newDown
dim as byte mDownLB, omDownLB, mDownRB, omDownRB
dim as byte showGrid = true
dim as integer curLine, editMode
dim as integer mx, my, mb
dim as integer gridMaxX = 32, gridMaxY = 32, scrMidX = 320, scrMidY = 240
dim as integer gridScrMidX = 320, gridScrMidY = 240
dim as integer gridX, gridY, gridZ = 14, gridZ2 = gridZ shr 1

dim as integer sx
dim as integer sy
dim as integer x1
dim as integer y1
dim as integer x2
dim as integer y2
dim as integer col

dim as FB.IMAGE ptr texture(0)
dim as vec2f box, checkBox
dim as string modelName = "Ship.mdata"


texture(0) = png_load( "data/visual/ship2.png", PNG_TARGET_FBNEW )

model.load(modelName)

do

	getmouse(mx,my,,mb)

	if multikey(FB.SC_UP) then

		curLine+=1

		if curLine > ubound(model.lines) then

			curLine = ubound(model.lines)

		end if

		wait_key( FB.SC_UP)

	end if


	if multikey(FB.SC_DOWN) then

		curLine-=1

		if curLine<0 then curLine = 0

		wait_key( FB.SC_DOWN)

	end if


	if multikey(FB.SC_M) then

		editMode +=1

		if editMode>1 then editMode = 0

		wait_key( FB.SC_M)

	end if


	if multikey(FB.SC_G) then
		showGrid = not showGrid
		wait_key( FB.SC_G)
	end if


	if multikey(FB.SC_S) then
		
		model.seal()
		
		model.save(modelName)

		wait_key( FB.SC_DOWN)

	end if


	if multikey(FB.SC_L) then

		model.load(modelName)

		wait_key( FB.SC_DOWN)

	end if


	if multikey(FB.SC_N) then

		newDown = true

	else

		newDown = false

	end if

	checkBox = vec2f(mx, my)

	omDownLB = mDownLB
	omDownRB = mDownRB
	mDownLB = false
	mDownRB = false

	if omDownLB<>mDownLB then
		model.seal()
	end if

	if mb and 1 then
		mDownLB = true
	end if

	if mb and 2 then
		mDownRB = true
	end if


	'clear the zBuffer
	dim as integer buffSize = 640*480
	asm
		xor eax, eax
		mov edi, [zbuff]
		mov ecx, [buffsize]
		rep stosd
	end asm


	screenlock
	cls

	if showGrid then

		dim as byte mouseIn = false

		for y as integer = 0 to gridMaxY
			for x as integer = 0 to gridMaxX

				sX = x*gridZ
				sY = y*gridZ

				x1 = scrMidX-gridZ2-(gridMaxX*gridZ2)+sx
				y1 = scrMidY-gridZ2-(gridMaxY*gridZ2)+sy
				x2 = x1+gridZ
				y2 = y1+gridZ

				line(x1, y1)-(x2, y2),rgb(96,96,96),b

				if checkBox.x>=x1 and checkBox.x<=x2 then

					if checkBox.y>=y1 and checkBox.y<=y2 then

						mouseIn = true

						box = vec2f(x1,y1)

						if mDownLB then

							if not newDown then

								if editMode = 0 then

									model.lines(curLine).p2.x = x-(gridMaxX shr 1)
									model.lines(curLine).p2.y = y-(gridMaxY shr 1)

								else

									model.lines(curLine).t2.x = x
									model.lines(curLine).t2.y = y

								end if

							end if

						elseif mDownRB then

							for cL as integer = 0 to ubound(model.lines)

								if editMode = 0 then

									if x-(gridMaxX shr 1) = model.lines(cL).p2.x then
										if y-(gridMaxY shr 1) = model.lines(cL).p2.y then
											curLine = cL
										end if
									end if

								else

									if x = model.lines(cL).t2.x then
										if y = model.lines(cL).t2.y then
											curLine = cL
										end if
									end if

								end if

							next

						end if

					end if

				end if

			next
		next

		if mouseIn then line(box.x, box.y) - (box.x+gridZ, box.y+gridZ),rgb(255,255,255),b

		with model
			for i as integer = 0 to ubound(.lines)
				
				if editMode = 0 then
				
					sx = (.lines(i).p2.x+(gridMaxX shr 1))*gridZ
					sy = (.lines(i).p2.y+(gridMaxY shr 1))*gridZ
					
					x1 = (scrMidX-gridZ2-(gridMaxX*gridZ2)+sx)
					y1 = (scrMidY-gridZ2-(gridMaxY*gridZ2)+sy)
					x2 = x1+gridZ
					y2 = y1+gridZ
					
				else
					
					sx = .lines(i).t2.x*gridZ
					sy = .lines(i).t2.y*gridZ
					
					x1 = (scrMidX-gridZ2-(gridMaxX*gridZ2)+sx)
					y1 = (scrMidY-gridZ2-(gridMaxY*gridZ2)+sy)
					x2 = x1+gridZ
					y2 = y1+gridZ
					
				end if

				
				col = rgb(255,255,0)

				if i = curLine then
					col = rgb(255,0,0)
				end if
				
				circle((x1+x2) shr 1, (y1+y2) shr 1),5,col,,,,f

			next
		end with


		draw string (320-4,240-4),"C",rgb(255,255,255)


	else


		dim as vec2f p = vec2f(320,240)

		model.transform(p, 0, 5f, cam  )

'sub model_struct.transform( byref p as vec2f, byref angle as single, byref scale as single = 1, byref cam as camera_struct, byref forceRot as byte = false)

		dim as vec2f gCent = vec2f(16,16)

		for l as integer = 0 to ubound(model.tLines)

			dim as vec2f p1 = vec2f(p.x+model.tLines(l).p1.x, p.y+.model.tLines(l).p1.y)
			dim as vec2f p2 = vec2f(p.x+model.tLines(l).p2.x, p.y+.model.tLines(l).p2.y)
			dim as vec2f p3 = vec2f( p.x, p.y)

			dim as vec2f t1 = model.lines(l).t1*8'+gCent
			dim as vec2f t2 = model.lines(l).t2*8'+gCent
			dim as vec2f t3 = gCent*8'model.Centroid
			
			t1.x = cint(t1.x)
			t2.x = cint(t2.x)
			t3.x = cint(t3.x)
			
			t1.y = cint(t1.y)
			t2.y = cint(t2.y)
			t3.y = cint(t3.y)
			
			'model.Lines(l).t1 = t1'-gCent
			'model.Lines(l).t2 = t2'-gCent
			
			tfpcsptri_orig(, p1.x, p1.y, 1, t1.x, t1.y, p2.x, p2.y, 1, t2.x, t2.y, p3.x, p3.y, 1, t3.x, t3.y, 8, texture(0) )

			'ftri( , p1.x, p1.y, 1, p2.x, p2.y, 1, p3.x, p3.y, 1, rgb(255,0,0) )

			'line( p1.x, p1.y)-( p2.x, p2.y), rgb(255,255,0)

		next


	end if

	if editMode = 0 then

		draw string (1,1),"LINE",rgb(255,255,255)

	else

		draw string (1,1),"TEXTURE",rgb(255,255,255)

	end if



	screensync
	screenunlock

	sleep 3,1

loop until multikey(FB.SC_ESCAPE)


for t as integer = 0 to ubound(texture)
	png_destroy( texture(t) )
next

delete[] zBuff


function wait_key( byref Key as uinteger ) as byte

	do

		ScreenControl FB.POLL_EVENTS

	loop while multikey(Key)

	return true

end function







ship_data:

data 3

data 0,-13
data -5, 13

data -5,13
data 0, 5

data 0, 5
data 5,13

data 5,13
data 0,-13
