#include once "entity.bi"


sub update_player( pl as player_struct, Asteroids() as entity_struct, byref tDelta as single, byref cam as camera_struct )

	with pl

		.v += .targV * (.thrust * tDelta)
		.vMag = .v.magnitude()

		if .vMag >3 then
			.v.normalize()
			.v*=3
		end if

		.p += (.v * (tDelta*50))

		if .p.x<0 then .p.x = levWidth
		if .p.x>levWidth then .p.x = 0
		if .p.y<0 then .p.y = levHeight
		if .p.y>levHeight then .p.y = 0


		.model(0).transform( .p, .rot,, cam )

		.dirVec = vec2f( sin(.rot), -cos(.rot) )


		for i2 as integer = 0 to ubound(Asteroids)

			if Asteroids(i2).active and .active then

				dim as vec2f dVec = .p - Asteroids(i2).p

				dim as single d = (dVec.x*dVec.x)+(dVec.y*dVec.y)

				if d<= (.model(0).r^2 + Asteroids(i2).model(0).r^2)*3.5 then

					if check_model_model_collision( .model(0), .p, Asteroids(i2).model(0), Asteroids(i2).p ) >-1 then

						if not .modifiers and BONUS_ENUM.SHIELD then

							.doDeath = true
							.spawnWait = timer+3
							Asteroids(i2).doDeath = true
							
						end if

					end if

				end if

			end if
		next


		if .modifiers and BONUS_ENUM.SHIELD then

			if timer>.shieldTime then
				.modifiers xor = BONUS_ENUM.SHIELD
			end if

		end if
		
		
		if .modifiers and BONUS_ENUM.RETICLE then
			
			.retPat = (.retPat shr 2) or (.retPat shl 14)
			
			if timer>.reticleTime then
				.modifiers xor = BONUS_ENUM.RETICLE
			end if
			
		end if
		

	end with

end sub


sub player_struct.add_fuel( byref amt as single )
	
	fuel+=amt
	
	if fuel>maxFuel then
		
		fuel = maxFuel
		
	end if
	
end sub


sub player_struct.subtract_fuel( byref amt as single )
	
	fuel-=amt
	
	if fuel<0 then
		
		fuel = 0
		
	end if
	
end sub


sub player_struct.add_battery( byref amt as single )
	
	battery+=amt
	
	if battery>maxBattery then
		
		battery = maxBattery
		
	end if
	
end sub


sub player_struct.subtract_battery( byref amt as single )
	
	battery-=amt
	
	if battery<0 then
		
		battery = 0
		
	end if
	
end sub


sub update_asteroids( Asteroids() as entity_struct, byref tDelta as single, byref levelUp as byte, byref cam as camera_struct )

	levelUp = true

	for i as integer = 0 to ubound(Asteroids)

		if Asteroids(i).active then

			levelUp = false

			with Asteroids(i)

				.rot+=(.rotDelta*tDelta)

				.p+=.v*(.vDelta*tDelta)

				if .p.x<-50 then .p.x = levWidth+50
				if .p.x>levWidth+50 then .p.x = -50
				if .p.y<-50 then .p.y = levHeight+50
				if .p.y>levHeight+50 then .p.y = -50

				.model(0).transform( .p, .rot,, cam )

			end with


			for i2 as integer = 0 to ubound(Asteroids)
				if i2<>i and Asteroids(i2).active then

					dim as vec2f dVec = Asteroids(i).p - Asteroids(i2).p

					dim as single d = (dVec.x*dVec.x)+(dVec.y*dVec.y)

					if d<= (Asteroids(i).model(0).r^2 + Asteroids(i2).model(0).r^2)*3.5 then

						if check_model_model_collision( Asteroids(i).model(0), Asteroids(i).p, Asteroids(i2).model(0), Asteroids(i2).p ) >-1 then

							dim as single mag1 = Asteroids(i).v.magnitude()
							dim as single mag2 = Asteroids(i2).v.magnitude()
							dim as single magAve = (mag1+mag2)/2

							dim as vec2f nVec = dVec
							dVec.normalize()

							Asteroids(i).v.x = dVec.x*magAve
							Asteroids(i).v.y = dVec.y*magAve
							Asteroids(i2).v.x = dVec.x*-magAve
							Asteroids(i2).v.y = dVec.y*-magAve

						end if

					end if

				end if
			next

		end if

	next

end sub


sub particle_system.render(byref cam as camera_struct)


	for i as integer = ubound(parts) to 0 step-1

		with parts(i)

			if .active then
				
				dim as vec2f zP = .p*cam.zoom
				
				select case as const .pType

					case PARTICLE_ENUM.EXPLOSION

						dim as vec2f dl = .v
						dim as single mag = dl.magnitude()*2
						dl.normalize
						line(zP.x-cam.p.x, zP.y-cam.p.y)-((zP.x+dl.x*mag)-cam.p.x, (zP.y+dl.y*mag)-cam.p.y),.colour


					case PARTICLE_ENUM.THRUST

						dim as vec2f dl = .v
						dim as single mag = dl.magnitude()*.05
						dl.normalize
						'line( (zP.x-dl.x*mag)-cam.p.x, (zP.y-dl.y*mag)-cam.p.y)-( (zP.x+dl.x*mag)-cam.p.x,(zP.y+dl.y*mag)-cam.p.y),.colour
						'circle(zP.x-cam.p.x, zP.y-cam.p.y), .size, .colour
						
						dim as integer alphaCol = .colour.r
						if alphaCol<0 then alphaCol = 0
						if alphaCol>255 then alphaCol = 255
						
						rotozoom_alpha2( 0, .sprite, zP.x-cam.p.x, zP.y-cam.p.y, int(.rot), .size/20,,&h00000000,alphaCol )
						'rotozoom_alpha( , .sprite, zP.x-cam.p.x, zP.y-cam.p.y, int(.rot), .size/40,.size/40,&hffff00ff )

					case PARTICLE_ENUM.PING

						if .size=0 then .size = 1

						for s as single = .size/2 to .size step .size/4

							circle(zP.x-cam.p.x, zP.y-cam.p.y), s, .colour,.rot-.5,.rot+.5

						next


					case PARTICLE_ENUM.SHIELD

						dim as vec2f p1 = .p-cam.p
						dim as vec2f p2 = .pb-cam.p

						line(p1.x, p1.y)-(p2.x, p2.y),.colour,,&b1100110011001100

				end select

			end if

		end with

	next

end sub


sub particle_system.init( byref cnt as integer )

	redim parts(cnt)

end sub


sub particle_system.update( byref tDelta as single, byref cam as camera_struct )

	dim as double cTime = timer

	for i as integer = 0 to ubound(parts)

		with parts(i)

			if .active then

				select case as const .pType


					case PARTICLE_ENUM.EXPLOSION

						.p+=.v*(tDelta*50)
						.v += .v*(.vDecay*tDelta)

						.colour.r+= tDelta*.colDelta.r
						.colour.g+= tDelta*.colDelta.g
						.colour.b+= tDelta*.colDelta.b

						if cTime>.lSpan then
							.active = false
						end if


					case PARTICLE_ENUM.THRUST

						.p+=(.v*(tDelta))*cam.zoom
						.v += (.v*(.vDecay*tDelta))*cam.zoom

						.size+=(.sizeDelta*tDelta)*cam.zoom

						.colour.r+= tDelta*.colDelta.r
						.colour.g+= tDelta*.colDelta.g
						.colour.b+= tDelta*.colDelta.b

						if cTime>.lSpan then
							.active = false
						end if


					case PARTICLE_ENUM.PING

						.size += (.sizeDelta*tDelta)*cam.zoom
						if .size>.sizeMax then
							.active = false
						end if


					case PARTICLE_ENUM.SHIELD

						.p+=(.v*(tDelta*5))*cam.zoom
						.pb+=(.v*(tDelta*5))*cam.zoom

						.v += (.v*(.vDecay*tDelta))*cam.zoom

						.colour.r+= tDelta*.colDelta.r
						.colour.g+= tDelta*.colDelta.g
						.colour.b+= tDelta*.colDelta.b

						if cTime>.lSpan then
							.active = false
						end if



				end select

			end if

		end with

	next

end sub


sub particle_system.spawn_shield(byref sp as vec2f, byref ep as vec2f, byref vel as vec2f )

	dim as vec2f mp = (sp+ep)/2
	dim as vec2f perp = ep.perp(sp)
	perp.Normalize()

	static as integer cntr

	cntr+=1
	if cntr>10 then cntr = 0

	for i as integer = 0 to ubound(parts)

		with parts(i)

			if not .active then

				.active = true
				.lSpan = timer+.025
				.p = sp
				.pb = ep
				.v = perp*(50+cntr)
				.colour = rgb_struct(0,0,255)
				.colDelta = rgb_struct(10000,10000,0)
				.vDecay = -5.59
				.pType = PARTICLE_ENUM.SHIELD

				exit sub

			end if

		end with

	next

end sub


sub particle_system.spawn_explosion( byref posit as vec2f, byref mag as single, byref maxParts as integer = 19, byref partType as PARTICLE_ENUM, byref lifeSpan as single)

	for ri as integer = 0 to maxParts

		dim as single radian = ri * ( PI2 / (maxParts+1) )

		for ti as integer = 0 to ubound(parts)

			with parts(ti)

				if not .active then
					.active = true
					.p = posit + vec2f(3*sin(radian), 3*cos(radian))
					.v = vec2f(sin(radian), cos(radian))*(mag+rnd*(mag*8))
					.lSpan = lifeSpan
					.pType = partType

					.colour = rgb_struct(255,255,0)
					.colDelta = rgb_struct(-510,-510,0)
					.vDecay = -5.59
					exit for
				end if

			end with

		next

	next

end sub


sub particle_system.spawn_ping( byref posit as vec2f, byref radDelta as single, byref ang as single, byref partType as PARTICLE_ENUM )


	for ti as integer = 0 to ubound(parts)

		with parts(ti)

			if not .active then

				.active = true
				.p = posit
				.lSpan = timer+2
				.pType = partType
				.colour = type(255,255,0)
				.vDecay = 0
				.size = 0
				.sizeDelta = 200
				.sizeMax = 50
				.rot = ang

				exit sub

			end if

		end with

	next


end sub


sub particle_system.spawn_thrust( byref posit as vec2f, byref v1 as vec2f,  byref v2 as vec2f, byref vel as vec2f, byref ang as single, byref sprite as FB.IMAGE ptr, byref lifeSpan as single)

	static as vec2f endVec, randPoint, vecLine
	static as single dist
	static as single randDist


	for ti as integer = 0 to ubound(parts)
		with parts(ti)

			if not .active then

				if int(rnd*2) = 0 then
					endVec = v1
				else
					endVec = V2
				end if

				dist = posit.dist(endVec)
				randDist = rnd*dist
				vecLine = endVec-posit
				vecLine.normalize()

				randPoint = posit+vecLine*randDist
				
				.rot = rnd*360'ang 
				.active = true
				.p = randPoint
				.v = vel*3
				.lSpan = lifeSpan
				.sprite = sprite
				.pType = PARTICLE_ENUM.THRUST
				.colour = rgb_struct(128,255,0)
				.colDelta = rgb_struct(-300,-510,0)
				.vDecay = 0
				.size = rnd*.5
				.sizeDelta = 40
				exit sub
			end if

		end with
	next

end sub
