#include once "model.bi"


function model_struct.load( byref fName as string ) as byte

	dim as integer fNum = freefile

	open "data/model/" & fName for input as #fNum
	
	if Err>0 then
		
		print "Could not load file!"
		
		return false
		
	end if
	
	dim as string temp

	line input #fnum, temp

	redim lines(val(temp))
	redim tLines(val(temp))

	for i as integer = 0 to ubound(lines)

		line input #fnum, temp
		lines(i).p1.x = val(temp)
		line input #fnum, temp
		lines(i).p1.y = val(temp)
		
		line input #fnum, temp
		lines(i).t1.x = val(temp)
		line input #fnum, temp
		lines(i).t1.y = val(temp)
		
		
		line input #fnum, temp
		lines(i).p2.x = val(temp)
		line input #fnum, temp
		lines(i).p2.y = val(temp)
		
		line input #fnum, temp
		lines(i).t2.x = val(temp)
		line input #fnum, temp
		lines(i).t2.y = val(temp)
		
	next

	close #fNum

	return true

end function


function model_struct.save( byref fName as string ) as byte

	dim as integer fNum = freefile

	open "data/model/" & fName for output as #fNum
	
	if Err>0 then
		
		print "Could not save file!"
		
		return false
		
	end if
	
	print #fNum, ubound(lines)

	for i as integer = 0 to ubound(lines)

		print #fNum, lines(i).p1.x
		print #fNum, lines(i).p1.y
		print #fNum, lines(i).t1.x
		print #fNum, lines(i).t1.y
		
		print #fNum, lines(i).p2.x
		print #fNum, lines(i).p2.y
		print #fNum, lines(i).t2.x
		print #fNum, lines(i).t2.y

	next

	close #fNum

	return true

end function


sub model_struct.seal()

	for i as integer = 0 to ubound(lines)

		dim as integer iand1 = (i+1) mod (ubound(lines)+1)

		lines(iand1).p1 = lines(i).p2
		tLines(iand1).p1 = tLines(i).p2
		
		lines(iand1).t1 = lines(i).t2
		tLines(iand1).t1 = tLines(i).t2
		
	next

end sub


sub model_struct.transform( byref p as vec2f, byref angle as single, byref scale as single = 1, byref cam as camera_struct, byref forceRot as byte = false)
	
	static as single tScale
	static as byte doRot	
	
	 doRot = true

	if p.x - cam.p.x>-50 and p.x - cam.p.x<690 then

		if p.y - cam.p.y>-50 and p.y - cam.p.y<530 then

			doRot = true

		end if

	end if
	
	if forceRot then doRot = true
	
	if scale<>1 then
		
		tScale = scale
		
	else
		
		tScale = cam.zoom
		
	end if
	
	
	if doRot then
		
		for i as integer = 0 to ubound(lines)
			
			'tLines(i).p1.x = (lines(i).p1.x * cos(angle) - lines(i).p1.y * sin(angle)) * tScale
			'tLines(i).p1.y = (lines(i).p1.y * cos(angle) + lines(i).p1.x * sin(angle)) * tScale
			tLines(i).p2.x = (lines(i).p2.x * cos(angle) - lines(i).p2.y * sin(angle)) * tScale
			tLines(i).p2.y = (lines(i).p2.y * cos(angle) + lines(i).p2.x * sin(angle)) * tScale
			
		next
		
		seal()
		
		
	end if

end sub


sub model_struct.center()

	dim as vec2f avg

	for i as integer = 0 to ubound(lines)

		avg += lines(i).p1
		avg += lines(i).p2

	next

	dim as single cnt = ubound(lines)*2

	avg.x\=cnt
	avg.y\=cnt
	
	centroid = avg
	
	for i as integer = 0 to ubound(lines)

		lines(i).p1 -= avg
		lines(i).p2 -= avg

	next


end sub


function check_model_model_collision( byref modelA as model_struct, byref pA as vec2f = vec2f(0,0), byref modelB as model_struct, byref pB as vec2f = vec2f(0,0), byref iPoint as vec2f = vec2f(0,0) ) as integer

	for l1 as integer = 0 to ubound(modelA.tLines)
		for l2 as integer = 0 to ubound(modelB.tLines)

			if lines_intersect( iPoint, modelA.tLines(l1).p1+pA, modelA.tLines(l1).p2+pA, modelB.tLines(l2).p1+pB, modelB.tLines(l2).p2+pB) then

				return l1

			end if

		next
	next

	return -1

end function


function check_line_model_collision( byref pa as vec2f, byref pb as vec2f, byref model as model_struct, byref p as vec2f, byref iPoint as vec2f = vec2f(0,0) ) as integer

	for l as integer = 0 to ubound(model.tLines)

		if lines_intersect( iPoint, pa, pb, model.tLines(l).p1+p, model.tLines(l).p2+p) then

			return l

		end if

	next

	return -1

end function
